// client_exc.cpp : Defines the entry point for the application.
//


#include "resource.h"
#include <stdio.h>
#include <objbase.h>
#include <initguid.h>
#include "office.h"


#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text
HWND hWnd;
char str1[30], str2[30];
// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
BOOL	CALLBACK	EnumWndProc(HWND hwnd, LPARAM lParam);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CLIENT_EXC, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CLIENT_EXC);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_CLIENT_EXC);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_CLIENT_EXC;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				case ID_FILE_WORD:
				{
				  CoInitialize(NULL);
				  SYSTEMTIME t;
				  GetLocalTime(&t);				  
				  sprintf(str1,"%.2d:%.2d:%.2d:%.3d",t.wHour,t.wMinute,t.wSecond,t.wMilliseconds);
				  try
				  {
					  using namespace Word;
					  _ApplicationPtr word(L"Word.Application");
					  word->Visible=true;
					  word->Activate();

					  _DocumentPtr doc=word->Documents->Add();
					  RangePtr range=doc->Content;
					  range->LanguageID=wdRussian;
					  range->InsertAfter("  :)");
					
				  }
				  catch(_com_error &er)
					{
					 char buf[1024];
					 sprintf(buf,"_com_error:\n"
									"Error			:%08lX\n"
									"Error message	:%s\n"
									"Description	:%s\n"
									"Source			:%s\n",
									er.Error(),er.ErrorMessage(),er.Description(),er.Source());
					 MessageBox(hWnd,buf,"",0);
					 
					}
					        
				             GetLocalTime(&t);
					         sprintf(str2,"%.2d:%.2d:%.2d:%.3d",t.wHour,t.wMinute,t.wSecond,t.wMilliseconds);
        					 CoUninitialize();
							 InvalidateRect(hWnd,NULL,TRUE);
				 
				}
				break;
				case ID_FILE_EXCEL:
				{
				  CoInitialize(NULL);
				  SYSTEMTIME t;
				  GetLocalTime(&t);				  
				  sprintf(str1,"%.2d:%.2d:%.2d:%.3d",t.wHour,t.wMinute,t.wSecond,t.wMilliseconds);
				  
					try
					{
						using namespace Excel;
						_ApplicationPtr excel (L"Excel.Application");
						excel->Visible[0]=true;
						// 
						excel->PutCaption("MyDoc");
						//create new book
						_WorkbookPtr book=excel->Workbooks->Add();
						//get first list
						_WorksheetPtr sheet=book->Worksheets->Item[1L];
						sheet->Range["B2"]->FormulaR1C1="String 1";
						sheet->Range["B3"]->FormulaR1C1=book->Name;
						sheet->Range["B4"]->FormulaR1C1=sheet->Name;
						sheet->Range["B5"]->FormulaR1C1="Hello";
						
							///////////////
						sheet->Range["C2"]->FormulaR1C1="1";
						sheet->Range["C3"]->FormulaR1C1="2";
						sheet->Range["C4"]->FormulaR1C1="3";
						sheet->Range["C5"]->FormulaR1C1="4";
						sheet->Range["C6"]->FormulaR1C1="5";
						sheet->Range["C7"]->FormulaR1C1="Itog";
						sheet->Range["C8"]->FormulaR1C1="=SUM(R[-6]C:R[-2]C)";
						sheet->Range["C8"]->Activate();

						sheet->Range["B2:B5"]->Font->ColorIndex=27L;
						sheet->Range["C7:C8"]->Interior->ColorIndex=15L;

						// 
						sheet->Range["C2:C6"]->Select();
						// 
						book->Charts->Add();
						// 
						book->ActiveChart->ChartType=xlLineMarkers;
					
									
						XlRowCol xl;
						xl=xlColumns;
						
				
						book->ActiveChart->SetSourceData(sheet->Range["C2:C6"],(long)xl);
						//  
						book->ActiveChart->Location(xlLocationAsObject,L"1");
						//	WaitForSingleObject(NULL,2000);
						::hWnd=hWnd;
					
					//	EnumWindows(&EnumWndProc,0);
						/*

							Range("C5:C13").Select
    Charts.Add
    ActiveChart.ChartType = xlLineMarkers
    ActiveChart.SetSourceData Source:=Sheets("1").Range("C5:C13"), PlotBy:= _
        xlColumns
    ActiveChart.Location Where:=xlLocationAsObject, Name:="1"
 ActiveSheet.Pictures.Insert( _
        "E:\ \\8semestr\office_tech\lab3\smile.BMP").Select
						*/
					
					}
					catch(_com_error &er)
					{
					 char buf[1024];
					 sprintf(buf,"_com_error:\n"
									"Error			:%08lX\n"
									"Error message	:%s\n"
									"Description	:%s\n"
									"Source			:%s\n",
									er.Error(),er.ErrorMessage(),er.Description(),er.Source());
					 MessageBox(hWnd,buf,"",0);
					 
					}
					GetLocalTime(&t);
					 sprintf(str2,"%.2d:%.2d:%.2d:%.3d",t.wHour,t.wMinute,t.wSecond,t.wMilliseconds);
					 CoUninitialize();
					 InvalidateRect(hWnd,NULL,TRUE);
				}
				break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			TextOut(hdc,0,0,str1,strlen(str1));
			TextOut(hdc,0,30,str2,strlen(str2));
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			
			PostQuitMessage(0);
			
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

BOOL CALLBACK EnumWndProc(HWND hwnd, LPARAM lParam)
{
 int lenBuf=0;

   //SendMessage(hwnd,WM_GETTEXTLENGTH,(WPARAM)(&lenBuf),0);
	lenBuf=GetWindowTextLength(hwnd);
   char *Buf;
   Buf=new char[++lenBuf];
   //SendMessage(hwnd,WM_GETTEXT,0,(LPARAM)(LPCSTR)Buf);
   GetWindowText(hwnd,Buf,lenBuf+1);
   
	if(!strcmp(Buf,"MyDoc - 2"))
	{	  
	 SetParent(hwnd,hWnd);
	 InvalidateRect(hwnd,NULL,TRUE);
	 InvalidateRect(hWnd,NULL,TRUE);
	 return FALSE;
	}
	return TRUE;
}
